Attribute VB_Name = "ModTagId3v2"
' *****************
' Lire les TAG id3
' *****************

'Option Explicit



Public i As Integer
Public strEmptyString As String
Public B As Byte
Public s As String

Private Type ID3v1Tag
  id As String * 3
  title As String * 30
  Artist As String * 30
End Type

Private Version As Byte

Sub LireTagID3(FichierTag$)
TagNom1$ = ""
TagArtist1$ = ""
TagNom2$ = ""
TagArtist2$ = ""
TagExist1 = 0
TagExist2 = 0
    


On Error GoTo errorhandler

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' use the filename to get ID3 info
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Dim strFilename As String
    Dim lngFilesize As Long
    
    strFilename = FichierTag$
    'MsgBox strFilename

    Dim fn As Integer
    Dim lngHeaderPosition As Long
    Dim Tag1 As ID3v1Tag
    Dim Tag2 As String
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Open the file
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    'fn = FreeFile
    fn = 1
    
    Open strFilename For Binary As #fn                      'Open the file so we can read it
    lngFilesize = LOF(fn)                                   'Size of the file, in bytes

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Check for a Header
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            
        Get #fn, 1, B
            
        If B <> 255 Then '(255 is where an ID3v2 header should start)
            If B <> 73 Then
                'Exit Function
            End If
        End If
         
        lngHeaderPosition = 1
        Get #fn, 2, B
        If (B < 250 Or B > 251) Then
            'We have an ID3v2 tag
            If B = 68 Then
                Get #fn, 3, B
                If B = 51 Then
                    Dim R As Double
                    Get #fn, 4, Version
                    Get #fn, 7, B
                    R = B * 20917152
                    Get #fn, 8, B
                    R = R + (B * 16384)
                    Get #fn, 9, B
                    R = R + (B * 128)
                    Get #fn, 10, B
                    R = R + B
                    If R > lngFilesize Or R > 2147483647 Then
                        Exit Sub
                    End If
                    Tag2 = Space$(R)
                    Get #fn, 11, Tag2
                    lngHeaderPosition = R + 11
                End If
            End If
        Else
            'ID3v2 tag is missing
        End If

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Check for an ID3v1 tag
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    'ID3v1 tag
        Get #fn, lngFilesize - 127, Tag1.id
        
        If Tag1.id = "TAG" Then 'If "TAG" is present, then we have a valid ID3v1 tag and will extract all available ID3v1 info from the file
           
            
debut = lngFilesize - &H80 + 3
TagNom1$ = ""
For i = 1 To &H1E
Get #1, debut + i, octet
If octet = 0 Then Exit For
TagNom1$ = TagNom1$ + Chr$(octet)
Next
TagNom1$ = LTrim$(RTrim$(TagNom1$))
debut = debut + &H1E
TagArtist1$ = ""
For i = 1 To &H1E
Get #1, debut + i, octet
If octet = 0 Then Exit For
TagArtist1$ = TagArtist1$ + Chr$(octet)
Next
TagNom1$ = Trim$(TagNom1$)
TagArtist1$ = Trim$(TagArtist1$)
                        
            
            TagExist1 = 1 'Indicates that the file contains ID3v1 tag info
    

            
        End If
        
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Proceed to extract the ID3v2 tag info if any exists
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
     
        If Tag2 <> strEmptyString Then
            TagExist2 = 1
            GetID3v2Tag1 (Tag2) 'Pass the Id3v2 TagId to the GetID3v2Tag1 function
        End If
        
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Close the file
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        Close #fn

    Exit Sub
        
errorhandler:
   ' MsgBox "Error reading file"
    Err.Clear
    Close #fn
    Resume Next
End Sub

Private Function GetID3v2Tag1(Tag2 As String) As Boolean

On Error GoTo errorhandler

   Dim TitleField As String
   Dim ArtistField As String
   Dim AlbumField As String
   Dim YearField As String
   Dim GenreField As String
   Dim FieldSize As Long
   Dim SizeOffset As Long
   Dim FieldOffset As Long
   Dim TrackNbr As String
   Dim SituationField As String
   
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Determine if the ID3v2 tag is ID3v2.2 or ID3v2.3
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'Notes: I haven't tested reading an MP3 file that has a ID3v2.2 tag
   
    Select Case Version
    
        Case 2 'ID3v2.2
        'Set the fieldnames for version 2.0
            TitleField = "TT2"
            ArtistField = "TOA"
            AlbumField = "TAL"
            YearField = "TYE"
            GenreField = "TCO"
            FieldOffset = 7
            SizeOffset = 5
            TrackNbr = "TRCK"
       
        Case 3 'ID3v2.3
        'Set the fieldnames for version 3.0
            TitleField = "TIT2"
            ArtistField = "TPE1"
            AlbumField = "TALB"
            YearField = "TYER"
            GenreField = "TCON"
            TrackNbr = "TRCK"
       
            FieldOffset = 11
            SizeOffset = 7
        Case Else
        'We don't have a valid ID3v2 tag, so bail
            Exit Function
            
    End Select
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Extract track title
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    
       i = InStr(Tag2, TitleField)
       If i > 0 Then
          'read the title
          FieldSize = Asc(Mid$(Tag2, i + SizeOffset)) - 1
          If Version = 3 Then
             'check for compressed or encrypted field
             B = Asc(Mid$(Tag2, i + 9))
             If (B And 128) = True Or (B And 64) = True Then GoTo ReadArtist
          End If
          
          TagNom2$ = Trim$(Mid$(Tag2, i + FieldOffset, FieldSize))
                             
       End If
       
 
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Extract artist name
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
ReadArtist:
   i = InStr(Tag2, ArtistField)
   If i > 0 Then
      FieldSize = Asc(Mid$(Tag2, i + SizeOffset)) - 1
      If Version = 3 Then
         'check for compressed or encrypted field
         B = Asc(Mid$(Tag2, i + 9))
         If (B And 128) = 128 Or (B And 64) = 64 Then GoTo Done
      End If
      
      TagArtist2$ = Trim$(Mid$(Tag2, i + FieldOffset, FieldSize))
          
   End If
   
   
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' We're done looking for ID3v2 info
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Done:
   
   Exit Function

errorhandler:
   Err.Clear
   Resume Next
End Function

